----------------------------------------------------------------------------------------------------------
--These TCs are created by APPLINK-15427, APPLINK-15164, APPLINK-9891 and APPLINK-18854
--APPLINK-15164 is not implemeted now
----------------------------------------------------------------------------------------------------------
config.defaultProtocolVersion = 2

Test = require('connecttest')
require('cardinalities')
local events = require('events')
local mobile_session = require('mobile_session')
local mobile  = require('mobile_connection')
local tcp = require('tcp_connection')
local file_connection  = require('file_connection')
local module = require('testbase')

---------------------------------------------------------------------------------------------
-----------------------------Required Shared Libraries---------------------------------------
---------------------------------------------------------------------------------------------
local commonFunctions = require('user_modules/shared_testcases/commonFunctions')
local commonSteps = require('user_modules/shared_testcases/commonSteps')
local commonTestCases = require('user_modules/shared_testcases/commonTestCases')
require('user_modules/AppTypes')

---------------------------------------------------------------------------------------------
------------------------------------ Common Variables ---------------------------------------
---------------------------------------------------------------------------------------------
local CorIdAlert
local AlertId
local SpeakId

---------------------------------------------------------------------------------------------
----------------------------------- Common Fuctions------------------------------------------
function Test:onEventChanged(enable,hmiLevel, audioStreamingState,case)
	--hmi side: send OnEventChanged (ON/OFF) notification to SDL
	self.hmiConnection:SendNotification("BasicCommunication.OnEventChanged",{isActive= enable, eventName="PHONE_CALL"})

	if enable==true then
		--Case: There are 3  applications
		if case== nil then

			--mobile side: expected OnHMIStatus
			self.mobileSession:ExpectNotification("OnHMIStatus",{hmiLevel = hmilevel, audioStreamingState = "NOT_AUDIBLE", systemContext = "MAIN"})
			self.mobileSession1:ExpectNotification("OnHMIStatus",{hmiLevel = "BACKGROUND", audioStreamingState = "NOT_AUDIBLE", systemContext = "MAIN"})
			 self.mobileSession2:ExpectNotification("OnHMIStatus",{hmiLevel = "BACKGROUND", audioStreamingState = "NOT_AUDIBLE", systemContext = "MAIN"})
		end

		--Case: There is one  application
		if case== 1 then
			self.mobileSession:ExpectNotification("OnHMIStatus",{hmiLevel = hmiLevel, audioStreamingState = audioStreamingState, systemContext = "MAIN"})
		end


	end

	if enable==false then

		--Case: There are 3  applications
		if case==nil then
			--mobile side: expected OnHMIStatus
			self.mobileSession:ExpectNotification("OnHMIStatus",{hmiLevel = hmilevel, audioStreamingState = "AUDIBLE", systemContext = "MAIN"})
			self.mobileSession1:ExpectNotification("OnHMIStatus",{hmiLevel = "LIMITED", audioStreamingState = "AUDIBLE", systemContext = "MAIN"})
			self.mobileSession2:ExpectNotification("OnHMIStatus",{hmiLevel = "LIMITED", audioStreamingState = "AUDIBLE", systemContext = "MAIN"})
		end

		--Case: There is one  application
		if case== 1 then
			self.mobileSession:ExpectNotification("OnHMIStatus",{hmiLevel = hmilevel, audioStreamingState = audioStreamingState, systemContext = "MAIN"})
		end
	end
end
-----------------------------------------------------------------------------------------

function Test:change_App_Params(app,appType,isMedia)
	local session

	if app==1 then
		session = config.application1.registerAppInterfaceParams
	end

	if app==2 then
		session = config.application2.registerAppInterfaceParams
	end

	if app==3 then
		session = config.application3.registerAppInterfaceParams
	end

	session.isMediaApplication = isMedia

	if appType=="" then
		session.appHMIType = nil
	else
		session.appHMIType = appType
	end
end
-----------------------------------------------------------------------------------------

function Test:registerAppInterface2()
	--mobile side: sending request
	local CorIdRegister = self.mobileSession1:SendRPC("RegisterAppInterface", config.application2.registerAppInterfaceParams)

	--hmi side: expect BasicCommunication.OnAppRegistered request
	EXPECT_HMINOTIFICATION("BasicCommunication.OnAppRegistered",
		{
			application =
			{
				appName = config.application2.registerAppInterfaceParams.appName
			}
		})
		:Do(function(_,data)
			self.applications[config.application2.registerAppInterfaceParams.appName] = data.params.application.appID
		end)

	--mobile side: expect response
	self.mobileSession1:ExpectResponse(CorIdRegister,
		{
			syncMsgVersion = config.syncMsgVersion
		})
		:Timeout(2000)

	--mobile side: expect notification
	self.mobileSession1:ExpectNotification("OnHMIStatus", {systemContext = "MAIN", hmiLevel = "NONE", audioStreamingState = "NOT_AUDIBLE"})
	:Timeout(2000)
end
------------------------------------------------------------------------------------------------

function Test:registerAppInterface3()
	--mobile side: sending request
	local CorIdRegister = self.mobileSession2:SendRPC("RegisterAppInterface", config.application3.registerAppInterfaceParams)

	--hmi side: expect BasicCommunication.OnAppRegistered request
	EXPECT_HMINOTIFICATION("BasicCommunication.OnAppRegistered",
		{
			application =
				{
					appName = config.application3.registerAppInterfaceParams.appName
				}
		})
		:Do(function(_,data)
			self.applications[config.application3.registerAppInterfaceParams.appName] = data.params.application.appID
	end)

	--mobile side: expect response
	self.mobileSession2:ExpectResponse(CorIdRegister,
		{
			syncMsgVersion = config.syncMsgVersion
		})
		:Timeout(2000)

	--mobile side: expect notification
	self.mobileSession2:ExpectNotification("OnHMIStatus", { systemContext = "MAIN", hmiLevel = "NONE", audioStreamingState = "NOT_AUDIBLE"})
		:Timeout(2000)
end
------------------------------------------------------------------------------------------------

function Test: bring_App_To_LIMITED()
	local cid = self.hmiConnection:SendNotification("BasicCommunication.OnAppDeactivated",
				{
					appID = self.applications[config.application1.registerAppInterfaceParams.appName],
					reason = "GENERAL"
				})

	self.mobileSession:ExpectNotification("OnHMIStatus",{hmiLevel = "LIMITED", audioStreamingState = "AUDIBLE", systemContext = "MAIN"})
end
------------------------------------------------------------------------------------------------

function Test:start_VRSESSION(hmiLevel)
	self.hmiConnection:SendNotification("VR.Started")
	self.hmiConnection:SendNotification("UI.OnSystemContext", {systemContext = "VRSESSION",appID = self.applications[config.application1.registerAppInterfaceParams.appName]})

	--mobile side: SDL send two notifications to mobile app
	self.mobileSession:ExpectNotification("OnHMIStatus",{hmiLevel = hmiLevel, audioStreamingState = "NOT_AUDIBLE", systemContext = "VRSESSION"})
end
------------------------------------------------------------------------------------------------

function Test:stop_VRSESSION(hmiLevel)
	--hmi side: send OnSystemContext
	self.hmiConnection:SendNotification("VR.Stopped")
	self.hmiConnection:SendNotification("UI.OnSystemContext", {systemContext = "MAIN",appID = self.applications[config.application1.registerAppInterfaceParams.appName]})

	--mobile side: SDL send 1 notification to mobile app
	self.mobileSession:ExpectNotification("OnHMIStatus",{hmiLevel = hmiLevel, audioStreamingState = "AUDIBLE", systemContext = "MAIN"})
end
------------------------------------------------------------------------------------------------

function Test:send_Alert(hmiLevel)
	--mobile side: Alert request
	CorIdAlert = self.mobileSession:SendRPC("Alert",
		{
			alertText1 = "alertText1",
			alertText2 = "alertText2",
			alertText3 = "alertText3",
			ttsChunks =
			{

				{
					text = "TTSChunk",
					type = "TEXT",
				}
			},
			duration = 5000,
			playTone = false,
			progressIndicator = true
		})

	--hmi side: UI.Alert request
	EXPECT_HMICALL("UI.Alert",
		{
			alertStrings =
			{
				{fieldName = "alertText1", fieldText = "alertText1"},
				{fieldName = "alertText2", fieldText = "alertText2"},
				{fieldName = "alertText3", fieldText = "alertText3"}
			},
			alertType = "BOTH",
			duration = 5000,
			progressIndicator = true
		})
		:Do(function(_,data)
			self.hmiConnection:SendNotification("UI.OnSystemContext",{ appID = self.applications[config.application1.registerAppInterfaceParams.appName], systemContext="ALERT"})

		--store id for response in next Test.
		AlertId = data.id

	end)

	--hmi side: TTS.Speak request
	EXPECT_HMICALL("TTS.Speak",
			{
				ttsChunks =
				{

					{
						text = "TTSChunk",
						type = "TEXT"
					}
				},
				speakType = "ALERT"
			})
	:Do(function(_,data)

		--store id for response in next Test.
		SpeakId = data.id

		local function TTS_Started()
			self.hmiConnection:SendNotification("TTS.Started")
		end

		RUN_AFTER(TTS_Started, 500)

	end)
	:ValidIf(function(_,data)
		if #data.params.ttsChunks == 1 then
			return true
		else
			print("ttsChunks array in TTS.Speak request has wrong element number. Expected 1, actual "..tostring(#data.params.ttsChunks))
			return false
		end
	end)

	--mobile side: Expected OnHMIStatus() notification
	EXPECT_NOTIFICATION("OnHMIStatus",
		{ systemContext = "ALERT", hmiLevel = hmiLevel, audioStreamingState = "AUDIBLE" },
		{ systemContext = "ALERT", hmiLevel = hmiLevel, audioStreamingState = "ATTENUATED"})
	:Times(2)
end
------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------
-------------------------------------------Preconditions-------------------------------------
---------------------------------------------------------------------------------------------

	--Print new line to separate new test cases group
	commonFunctions:newTestCasesGroup("****************************** Preconditions ******************************")

	--1.Delete Policy and Log Files
	commonSteps:DeleteLogsFileAndPolicyTable()

	--2.Unregister app
	commonSteps:UnregisterApplication()

	--3.Create second session
	function Test:Precondition_SecondSession()
		self.mobileSession1 = mobile_session.MobileSession(
		self,
		self.mobileConnection)
		self.mobileSession1:StartService(7)
	end

	--4.Create third session
	function Test:Precondition_SecondSession()
		self.mobileSession2 = mobile_session.MobileSession(
		self,
		self.mobileConnection)
		self.mobileSession2:StartService(7)
	end

----------------------------------------------------------------------------------------------
--Description: After receiving BasicCommunication.OnEventChanged(PHONE_CALL,ON) from HMI:
				--1.SDL deactivates Navigation app from (FULL, AUDIBLE) to (FULL, NOT_AUDIBLE)
				--2.SDL deactivates another apps (Media/Communication) to (BACKGROUND, NOT_AUDIBLE)
				--3.Restore app's state when received OnEventChanged(PHONE_CALL, OFF).
			local testData ={
				{app = "NAVIGATION",			appType ={"NAVIGATION"},	isMedia=false,	hmiLevel="LIMITED", 	audioStreamingState="NOT_AUDIBLE"},
				{app= "MEDIA",					appType ={"MEDIA"},			isMedia=true,	hmiLevel="BACKGROUND", 	audioStreamingState="NOT_AUDIBLE"},
				{app="NON MEDIA COMMUNICATION",	appType ={"COMMUNICATION"}, isMedia=false,	hmiLevel="BACKGROUND", 	audioStreamingState="NOT_AUDIBLE"}
			}

			for i =1, #testData do

				commonFunctions:newTestCasesGroup(testData[i].app.." app is FULL. HMI sends OnEventChanged(PHONE_CALL) with isActive: true then false")

				local function App_IsFull_PhoneCall_IsOn()

					function Test:Change_App1_Params()
						self:change_App_Params(1,testData[i].appType,testData[i].isMedia)
					end

					commonSteps:RegisterAppInterface()
					commonSteps:ActivationApp()

					function Test:PhoneCall_Event_ON()
						self:onEventChanged(true, testData[i].hmiLevel, testData[i].audioStreamingState,1)
					end

					function Test:PhoneCall_Event_OFF()
						self:onEventChanged(false, "FULL", "AUDIBLE",1)
					end
				end

				App_IsFull_PhoneCall_IsOn()

				--Poscontidion: Unregister app
				commonSteps:UnregisterApplication()
			end
			---------------------------------------------------------------------------------------------------------
